Index: uspace/drv/usbhub/usbhub.c
===================================================================
--- uspace/drv/usbhub/usbhub.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhub/usbhub.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -42,8 +42,8 @@
 #include <usb/ddfiface.h>
 #include <usb/descriptor.h>
-#include <usb/recognise.h>
-#include <usb/request.h>
+#include <usb/dev/recognise.h>
+#include <usb/dev/request.h>
 #include <usb/classes/hub.h>
-#include <usb/devpoll.h>
+#include <usb/dev/poll.h>
 #include <stdio.h>
 
@@ -51,7 +51,7 @@
 #include "usbhub_private.h"
 #include "port_status.h"
-#include "usb/usb.h"
-#include "usb/pipes.h"
-#include "usb/classes/classes.h"
+#include <usb/usb.h>
+#include <usb/dev/pipes.h>
+#include <usb/classes/classes.h>
 
 
@@ -71,4 +71,7 @@
 
 static void usb_hub_process_global_interrupt(usb_hub_info_t * hub_info);
+
+static void usb_hub_polling_terminted_callback(usb_device_t * device,
+    bool was_error, void * data);
 
 
@@ -351,5 +354,5 @@
 	rc = usb_device_auto_poll(hub_info->usb_device, 0,
 	    hub_port_changes_callback, ((hub_info->port_count + 1) / 8) + 1,
-	    NULL, hub_info);
+	    usb_hub_polling_terminted_callback, hub_info);
 	if (rc != EOK) {
 		usb_log_error("Failed to create polling fibril: %s.\n",
@@ -489,4 +492,23 @@
 
 /**
+ * callback called from hub polling fibril when the fibril terminates
+ *
+ * Should perform a cleanup - deletes hub_info.
+ * @param device usb device afected
+ * @param was_error indicates that the fibril is stoped due to an error
+ * @param data pointer to usb_hub_info_t structure
+ */
+static void usb_hub_polling_terminted_callback(usb_device_t * device,
+    bool was_error, void * data){
+	usb_hub_info_t * hub_info = data;
+	if(!hub_info) return;
+	free(hub_info->ports);
+	free(hub_info);
+}
+
+
+
+
+/**
  * @}
  */
Index: uspace/drv/usbhub/usbhub.h
===================================================================
--- uspace/drv/usbhub/usbhub.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhub/usbhub.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -39,9 +39,9 @@
 #include <ddf/driver.h>
 
-#include <usb/hub.h>
+#include <usb/dev/hub.h>
 #include <usb/classes/hub.h>
 
-#include <usb/pipes.h>
-#include <usb/devdrv.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/driver.h>
 
 #include <fibril_synch.h>
Index: uspace/drv/usbhub/usbhub_private.h
===================================================================
--- uspace/drv/usbhub/usbhub_private.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbhub/usbhub_private.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -47,5 +47,5 @@
 #include <usb/usb.h>
 #include <usb/debug.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 
 //************
Index: uspace/drv/usbmast/inquiry.c
===================================================================
--- uspace/drv/usbmast/inquiry.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmast/inquiry.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -34,5 +34,5 @@
  * Main routines of USB mass storage driver.
  */
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
Index: uspace/drv/usbmast/main.c
===================================================================
--- uspace/drv/usbmast/main.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmast/main.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -34,5 +34,5 @@
  * Main routines of USB mass storage driver.
  */
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
Index: uspace/drv/usbmast/mast.c
===================================================================
--- uspace/drv/usbmast/mast.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmast/mast.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -40,5 +40,5 @@
 #include <str_error.h>
 #include <usb/debug.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 
 bool usb_mast_verbose = true;
Index: uspace/drv/usbmast/mast.h
===================================================================
--- uspace/drv/usbmast/mast.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmast/mast.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -39,6 +39,6 @@
 #include <sys/types.h>
 #include <usb/usb.h>
-#include <usb/pipes.h>
-#include <usb/devdrv.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/driver.h>
 
 /** Result of SCSI INQUIRY command.
Index: uspace/drv/usbmid/dump.c
===================================================================
--- uspace/drv/usbmid/dump.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmid/dump.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,6 +37,6 @@
 #include <str_error.h>
 #include <stdlib.h>
-#include <usb/pipes.h>
-#include <usb/dp.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/dp.h>
 #include <usb/classes/classes.h>
 #include "usbmid.h"
Index: uspace/drv/usbmid/explore.c
===================================================================
--- uspace/drv/usbmid/explore.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmid/explore.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -38,6 +38,6 @@
 #include <stdlib.h>
 #include <usb/classes/classes.h>
-#include <usb/request.h>
-#include <usb/dp.h>
+#include <usb/dev/request.h>
+#include <usb/dev/dp.h>
 #include <usb/ddfiface.h>
 #include "usbmid.h"
Index: uspace/drv/usbmid/main.c
===================================================================
--- uspace/drv/usbmid/main.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmid/main.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -38,7 +38,7 @@
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 #include <usb/descriptor.h>
-#include <usb/pipes.h>
+#include <usb/dev/pipes.h>
 
 #include "usbmid.h"
Index: uspace/drv/usbmid/usbmid.c
===================================================================
--- uspace/drv/usbmid/usbmid.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmid/usbmid.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -39,7 +39,7 @@
 #include <usb_iface.h>
 #include <usb/ddfiface.h>
-#include <usb/pipes.h>
+#include <usb/dev/pipes.h>
 #include <usb/classes/classes.h>
-#include <usb/recognise.h>
+#include <usb/dev/recognise.h>
 #include "usbmid.h"
 
Index: uspace/drv/usbmid/usbmid.h
===================================================================
--- uspace/drv/usbmid/usbmid.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmid/usbmid.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -40,7 +40,7 @@
 #include <ddf/driver.h>
 #include <usb/usb.h>
-#include <usb/pipes.h>
+#include <usb/dev/pipes.h>
 #include <usb/debug.h>
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 #define NAME "usbmid"
Index: uspace/drv/usbmouse/init.c
===================================================================
--- uspace/drv/usbmouse/init.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmouse/init.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,6 +37,6 @@
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
-#include <usb/classes/hid.h>
-#include <usb/request.h>
+#include <usb/hid/hid.h>
+#include <usb/dev/request.h>
 #include <errno.h>
 
Index: uspace/drv/usbmouse/main.c
===================================================================
--- uspace/drv/usbmouse/main.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmouse/main.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -36,5 +36,5 @@
 #include "mouse.h"
 #include <usb/debug.h>
-#include <usb/devpoll.h>
+#include <usb/dev/poll.h>
 #include <errno.h>
 #include <str_error.h>
Index: uspace/drv/usbmouse/mouse.h
===================================================================
--- uspace/drv/usbmouse/mouse.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/usbmouse/mouse.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,6 +37,6 @@
 #define USBMOUSE_MOUSE_H_
 
-#include <usb/devdrv.h>
-#include <usb/pipes.h>
+#include <usb/dev/driver.h>
+#include <usb/dev/pipes.h>
 #include <time.h>
 
Index: uspace/drv/vhc/conndev.c
===================================================================
--- uspace/drv/vhc/conndev.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/vhc/conndev.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,7 +37,47 @@
 #include <errno.h>
 #include <ddf/driver.h>
+#include <usbvirt/ipc.h>
 #include "conn.h"
 
 static fibril_local uintptr_t plugged_device_handle = 0;
+#define PLUGGED_DEVICE_NAME_MAXLEN 256
+static fibril_local char plugged_device_name[PLUGGED_DEVICE_NAME_MAXLEN + 1] = "<unknown>";
+
+/** Receive device name.
+ *
+ * @warning Errors are silently ignored.
+ *
+ * @param phone Phone to the virtual device.
+ */
+static void receive_device_name(int phone)
+{
+	aid_t opening_request = async_send_0(phone, IPC_M_USBVIRT_GET_NAME, NULL);
+	if (opening_request == 0) {
+		return;
+	}
+
+
+	ipc_call_t data_request_call;
+	aid_t data_request = async_data_read(phone,
+	     plugged_device_name, PLUGGED_DEVICE_NAME_MAXLEN,
+	     &data_request_call);
+
+	if (data_request == 0) {
+		async_wait_for(opening_request, NULL);
+		return;
+	}
+
+	sysarg_t data_request_rc;
+	sysarg_t opening_request_rc;
+	async_wait_for(data_request, &data_request_rc);
+	async_wait_for(opening_request, &opening_request_rc);
+
+	if ((data_request_rc != EOK) || (opening_request_rc != EOK)) {
+		return;
+	}
+
+	size_t len = IPC_GET_ARG2(data_request_call);
+	plugged_device_name[len] = 0;
+}
 
 /** Default handler for IPC methods not handled by DDF.
@@ -65,6 +105,8 @@
 		async_answer_0(icallid, EOK);
 
-		usb_log_info("New virtual device `%s' (id = %" PRIxn ").\n",
-		    rc == EOK ? "XXX" : "<unknown>", plugged_device_handle);
+		receive_device_name(callback);
+
+		usb_log_info("New virtual device `%s' (id: %" PRIxn ").\n",
+		    plugged_device_name, plugged_device_handle);
 
 		return;
@@ -85,6 +127,6 @@
 
 	if (plugged_device_handle != 0) {
-		usb_log_info("Virtual device disconnected (id = %" PRIxn ").\n",
-		    plugged_device_handle);
+		usb_log_info("Virtual device `%s' disconnected (id: %" PRIxn ").\n",
+		    plugged_device_name, plugged_device_handle);
 		vhc_virtdev_unplug(vhc, plugged_device_handle);
 	}
Index: uspace/drv/vhc/connhost.c
===================================================================
--- uspace/drv/vhc/connhost.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/vhc/connhost.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -36,5 +36,4 @@
 #include <errno.h>
 #include <usb/usb.h>
-#include <usb/addrkeep.h>
 #include <usb/ddfiface.h>
 #include <usb/debug.h>
Index: uspace/drv/vhc/hub.c
===================================================================
--- uspace/drv/vhc/hub.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/vhc/hub.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -40,6 +40,6 @@
 #include <ddf/driver.h>
 #include <devman.h>
-#include <usb/hub.h>
-#include <usb/recognise.h>
+#include <usb/dev/hub.h>
+#include <usb/dev/recognise.h>
 
 #include "hub.h"
Index: uspace/drv/vhc/transfer.c
===================================================================
--- uspace/drv/vhc/transfer.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/vhc/transfer.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -4,8 +4,4 @@
 #include <usbvirt/ipc.h>
 #include "vhcd.h"
-
-#define list_foreach(pos, head) \
-	for (pos = (head)->next; pos != (head); \
-        	pos = pos->next)
 
 vhc_transfer_t *vhc_transfer_create(usb_address_t address, usb_endpoint_t ep,
@@ -67,7 +63,6 @@
 	fibril_mutex_lock(&vhc->guard);
 
-	link_t *pos;
 	bool target_found = false;
-	list_foreach(pos, &vhc->devices) {
+	list_foreach(vhc->devices, pos) {
 		vhc_virtdev_t *dev = list_get_instance(pos, vhc_virtdev_t, link);
 		fibril_mutex_lock(&dev->guard);
@@ -161,4 +156,36 @@
 }
 
+static vhc_transfer_t *dequeue_first_transfer(vhc_virtdev_t *dev)
+{
+	assert(fibril_mutex_is_locked(&dev->guard));
+	assert(!list_empty(&dev->transfer_queue));
+
+	vhc_transfer_t *transfer = list_get_instance(dev->transfer_queue.next,
+	    vhc_transfer_t, link);
+	list_remove(&transfer->link);
+
+	return transfer;
+}
+
+
+static void execute_transfer_callback_and_free(vhc_transfer_t *transfer,
+    size_t data_transfer_size, int outcome)
+{
+	assert(outcome != ENAK);
+
+	usb_log_debug2("Transfer %p ended: %s.\n",
+	    transfer, str_error(outcome));
+
+	if (transfer->direction == USB_DIRECTION_IN) {
+		transfer->callback_in(transfer->ddf_fun, outcome,
+		    data_transfer_size, transfer->callback_arg);
+	} else {
+		assert(transfer->direction == USB_DIRECTION_OUT);
+		transfer->callback_out(transfer->ddf_fun, outcome,
+		    transfer->callback_arg);
+	}
+
+	free(transfer);
+}
 
 int vhc_transfer_queue_processor(void *arg)
@@ -174,7 +201,5 @@
 		}
 
-		vhc_transfer_t *transfer = list_get_instance(dev->transfer_queue.next,
-		    vhc_transfer_t, link);
-		list_remove(&transfer->link);
+		vhc_transfer_t *transfer = dequeue_first_transfer(dev);
 		fibril_mutex_unlock(&dev->guard);
 
@@ -214,15 +239,6 @@
 
 		if (rc != ENAK) {
-			usb_log_debug2("Transfer %p ended: %s.\n",
-			    transfer, str_error(rc));
-			if (transfer->direction == USB_DIRECTION_IN) {
-				transfer->callback_in(transfer->ddf_fun, rc,
-				    data_transfer_size, transfer->callback_arg);
-			} else {
-				assert(transfer->direction == USB_DIRECTION_OUT);
-				transfer->callback_out(transfer->ddf_fun, rc,
-				    transfer->callback_arg);
-			}
-			free(transfer);
+			execute_transfer_callback_and_free(transfer,
+			    data_transfer_size, rc);
 		}
 
@@ -231,8 +247,12 @@
 	}
 
+	/* Immediately fail all remaining transfers. */
+	while (!list_empty(&dev->transfer_queue)) {
+		vhc_transfer_t *transfer = dequeue_first_transfer(dev);
+		execute_transfer_callback_and_free(transfer, 0, EBADCHECKSUM);
+	}
+
 	fibril_mutex_unlock(&dev->guard);
 
-	// TODO - destroy pending transfers
-
 	return EOK;
 }
Index: uspace/lib/block/libblock.c
===================================================================
--- uspace/lib/block/libblock.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/block/libblock.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -51,4 +51,6 @@
 #include <macros.h>
 #include <mem.h>
+#include <malloc.h>
+#include <stdio.h>
 #include <sys/typefmt.h>
 #include <stacktrace.h>
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/Makefile	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -41,12 +41,23 @@
 CONFIG_MAKEFILE = $(ROOT_PATH)/Makefile.config
 
+LINKER_SCRIPTS = \
+	$(LIBC_PREFIX)/arch/$(UARCH)/_link.ld \
+	$(LIBC_PREFIX)/arch/$(UARCH)/_link-loader.ld \
+	$(LIBC_PREFIX)/arch/$(UARCH)/_link-shlib.ld \
+	$(LIBC_PREFIX)/arch/$(UARCH)/_link-dlexe.ld
+
 PRE_DEPEND = $(INCLUDE_KERNEL) $(INCLUDE_ARCH) $(INCLUDE_LIBARCH) $(COMMON_HEADER_ARCH)
-EXTRA_OUTPUT = $(LINKER_SCRIPT)
-EXTRA_CLEAN = $(INCLUDE_KERNEL) $(INCLUDE_ARCH) $(INCLUDE_LIBARCH) $(COMMON_HEADER_ARCH) $(LINKER_SCRIPT)
+EXTRA_OUTPUT = $(LINKER_SCRIPTS)
+EXTRA_CLEAN = $(INCLUDE_KERNEL) $(INCLUDE_ARCH) $(INCLUDE_LIBARCH) $(COMMON_HEADER_ARCH) $(LINKER_SCRIPTS)
 LIBRARY = libc
+SLIBRARY = libc.so.0.0
+LSONAME = libc.so0
+
 
 -include $(COMMON_MAKEFILE)
 -include $(CONFIG_MAKEFILE)
 -include arch/$(UARCH)/Makefile.inc
+
+EXTRA_CFLAGS += -I../../srv/loader/include
 
 GENERIC_SOURCES = \
@@ -98,4 +109,5 @@
 	generic/adt/measured_strings.c \
 	generic/adt/char_map.c \
+	generic/adt/prodcons.c \
 	generic/time.c \
 	generic/stdlib.c \
@@ -114,5 +126,16 @@
 	generic/arg_parse.c \
 	generic/sort.c \
-	generic/stats.c
+	generic/stats.c \
+	generic/assert.c
+
+ifeq ($(CONFIG_RTLD), y)
+	GENERIC_SOURCES += \
+		generic/dlfcn.c \
+		generic/rtld/rtld.c \
+		generic/rtld/elf_load.c \
+		generic/rtld/dynamic.c \
+		generic/rtld/module.c \
+		generic/rtld/symbol.c
+endif
 
 SOURCES = \
@@ -133,6 +156,15 @@
 	ln -sfn ../$< $@
 
-$(LINKER_SCRIPT): $(LINKER_SCRIPT).in
+$(LIBC_PREFIX)/arch/$(UARCH)/_link.ld: $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld.in
 	$(GCC) $(DEFS) $(CFLAGS) -DLIBC_PATH=$(CURDIR) -E -x c $< | grep -v "^\#" > $@
+
+$(LIBC_PREFIX)/arch/$(UARCH)/_link-loader.ld: $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld.in
+	$(GCC) $(DEFS) $(CFLAGS) -DLIBC_PATH=$(CURDIR) -DLOADER -E -x c $< | grep -v "^\#" > $@
+
+$(LIBC_PREFIX)/arch/$(UARCH)/_link-shlib.ld: $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld.in
+	$(GCC) $(DEFS) $(CFLAGS) -DLIBC_PATH=$(CURDIR) -DSHLIB -E -x c $< | grep -v "^\#" > $@
+
+$(LIBC_PREFIX)/arch/$(UARCH)/_link-dlexe.ld: $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld.in
+	$(GCC) $(DEFS) $(CFLAGS) -DLIBC_PATH=$(CURDIR) -DDLEXE -E -x c $< | grep -v "^\#" > $@
 
 $(COMMON_HEADER_ARCH): $(COMMON_HEADER)
Index: uspace/lib/c/arch/abs32le/Makefile.inc
===================================================================
--- uspace/lib/c/arch/abs32le/Makefile.inc	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/abs32le/Makefile.inc	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -29,4 +29,5 @@
 ARCH_SOURCES = \
 	arch/$(UARCH)/src/entry.c \
+	arch/$(UARCH)/src/entryjmp.c \
 	arch/$(UARCH)/src/thread_entry.c \
 	arch/$(UARCH)/src/fibril.c \
Index: uspace/lib/c/arch/abs32le/_link.ld.in
===================================================================
--- uspace/lib/c/arch/abs32le/_link.ld.in	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/abs32le/_link.ld.in	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -3,11 +3,23 @@
 
 PHDRS {
+#ifdef LOADER
+	interp PT_INTERP;
+	text PT_LOAD FILEHDR PHDRS FLAGS(5);
+#else
 	text PT_LOAD FLAGS(5);
+#endif
 	data PT_LOAD FLAGS(6);
 }
 
 SECTIONS {
+#ifdef LOADER
+	.interp : {
+		*(.interp);
+	} :interp
+	
+	. = 0x70001000 + SIZEOF_HEADERS;
+#else
 	. = 0x1000 + SIZEOF_HEADERS;
-	
+#endif
 	.text : {
 		*(.text .text.*);
Index: uspace/lib/c/arch/abs32le/src/entryjmp.c
===================================================================
--- uspace/lib/c/arch/abs32le/src/entryjmp.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
+++ uspace/lib/c/arch/abs32le/src/entryjmp.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file
+ */
+
+#include <bool.h>
+#include <entry_point.h>
+
+/** Jump to program entry point. */
+void entry_point_jmp(void *entry_point, void *pcb)
+{
+	while (true);
+}
+
+/**
+ * @}
+ */
Index: uspace/lib/c/arch/amd64/Makefile.inc
===================================================================
--- uspace/lib/c/arch/amd64/Makefile.inc	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/amd64/Makefile.inc	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -29,4 +29,5 @@
 ARCH_SOURCES = \
 	arch/$(UARCH)/src/entry.s \
+	arch/$(UARCH)/src/entryjmp.s \
 	arch/$(UARCH)/src/thread_entry.s \
 	arch/$(UARCH)/src/syscall.S \
Index: uspace/lib/c/arch/amd64/_link.ld.in
===================================================================
--- uspace/lib/c/arch/amd64/_link.ld.in	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/amd64/_link.ld.in	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -3,5 +3,10 @@
 
 PHDRS {
+#ifdef LOADER
+	interp PT_INTERP;
+	text PT_LOAD FILEHDR PHDRS FLAGS(5);
+#else
 	text PT_LOAD FLAGS(5);
+#endif
 	data PT_LOAD FLAGS(6);
 	debug PT_NOTE;
@@ -9,6 +14,13 @@
 
 SECTIONS {
+#ifdef LOADER
+	.interp : {
+		*(.interp);
+	} :interp
+	
+	. = 0x70001000 + SIZEOF_HEADERS;
+#else
 	. = 0x1000 + SIZEOF_HEADERS;
-	
+#endif
 	.init : {
 		*(.init);
Index: uspace/lib/c/arch/amd64/src/entryjmp.s
===================================================================
--- uspace/lib/c/arch/amd64/src/entryjmp.s	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
+++ uspace/lib/c/arch/amd64/src/entryjmp.s	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -0,0 +1,43 @@
+#
+# Copyright (c) 2008 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+.globl entry_point_jmp
+
+## void entry_point_jmp(void *entry_point, void *pcb);
+#
+# %rdi	contains entry_point
+# %rsi	contains pcb
+#
+# Jump to program entry point
+entry_point_jmp:
+	# pcb must be passed in %rdi, use %rdx as a scratch register
+	mov %rdi, %rdx
+	mov %rsi, %rdi
+
+	# jump to entry point
+	jmp %rdx
Index: uspace/lib/c/arch/arm32/Makefile.inc
===================================================================
--- uspace/lib/c/arch/arm32/Makefile.inc	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/arm32/Makefile.inc	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -30,4 +30,5 @@
 ARCH_SOURCES = \
 	arch/$(UARCH)/src/entry.s \
+	arch/$(UARCH)/src/entryjmp.s \
 	arch/$(UARCH)/src/thread_entry.s \
 	arch/$(UARCH)/src/syscall.c \
Index: uspace/lib/c/arch/arm32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/arm32/_link.ld.in	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/arm32/_link.ld.in	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -3,11 +3,23 @@
 
 PHDRS {
+#ifdef LOADER
+	interp PT_INTERP;
+	text PT_LOAD FILEHDR PHDRS FLAGS(5);
+#else
 	text PT_LOAD FLAGS(5);
+#endif
 	data PT_LOAD FLAGS(6);
 }
 
 SECTIONS {
+#ifdef LOADER
+	.interp : {
+		*(.interp);
+	} :interp
+	
+	. = 0x70001000 + SIZEOF_HEADERS;
+#else
 	. = 0x1000 + SIZEOF_HEADERS;
-	
+#endif
 	.init : {
 		*(.init);
Index: uspace/lib/c/arch/arm32/src/entryjmp.s
===================================================================
--- uspace/lib/c/arch/arm32/src/entryjmp.s	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
+++ uspace/lib/c/arch/arm32/src/entryjmp.s	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -0,0 +1,42 @@
+#
+# Copyright (c) 2008 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+.globl entry_point_jmp
+
+## void entry_point_jmp(void *entry_point, void *pcb);
+#
+# r0	contains entry_point
+# r1	contains pcb
+#
+# Jump to program entry point
+entry_point_jmp:
+	# load ras_page address to r2
+	ldr r2, =ras_page
+	ldr r2, [r2]
+	# pcb is passed to the entry point in r1 (where it already is)
+	mov r15, r0
Index: uspace/lib/c/arch/ia32/Makefile.common
===================================================================
--- uspace/lib/c/arch/ia32/Makefile.common	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/ia32/Makefile.common	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -28,5 +28,5 @@
 
 CLANG_ARCH = i386
-GCC_CFLAGS += -march=pentium
+GCC_CFLAGS += -march=pentium -fno-omit-frame-pointer
 
 ENDIANESS = LE
Index: uspace/lib/c/arch/ia32/Makefile.inc
===================================================================
--- uspace/lib/c/arch/ia32/Makefile.inc	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/ia32/Makefile.inc	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -29,4 +29,5 @@
 ARCH_SOURCES = \
 	arch/$(UARCH)/src/entry.s \
+	arch/$(UARCH)/src/entryjmp.s \
 	arch/$(UARCH)/src/thread_entry.s \
 	arch/$(UARCH)/src/syscall.S \
@@ -35,5 +36,7 @@
 	arch/$(UARCH)/src/setjmp.S \
 	arch/$(UARCH)/src/stacktrace.c \
-	arch/$(UARCH)/src/stacktrace_asm.S
+	arch/$(UARCH)/src/stacktrace_asm.S \
+	arch/$(UARCH)/src/rtld/dynamic.c \
+	arch/$(UARCH)/src/rtld/reloc.c
 
 .PRECIOUS: arch/$(UARCH)/src/entry.o
Index: uspace/lib/c/arch/ia32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/ia32/_link.ld.in	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/ia32/_link.ld.in	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -1,14 +1,32 @@
+#ifndef SHLIB
 STARTUP(LIBC_PATH/arch/UARCH/src/entry.o)
 ENTRY(__entry)
+#endif
 
 PHDRS {
+#if defined(LOADER) || defined(DLEXE)
+	interp PT_INTERP;
+	text PT_LOAD FILEHDR PHDRS FLAGS(5);
+#else
 	text PT_LOAD FLAGS(5);
+#endif
 	data PT_LOAD FLAGS(6);
+#if defined(SHLIB) || defined(DLEXE)
+	dynamic PT_DYNAMIC;
+#endif
 	debug PT_NOTE;
 }
 
 SECTIONS {
+#if defined(LOADER) || defined(DLEXE)
+	.interp : {
+		*(.interp);
+	} :interp
+#endif
+#ifdef LOADER
+	. = 0x70001000 + SIZEOF_HEADERS;
+#else
 	. = 0x1000 + SIZEOF_HEADERS;
-	
+#endif
 	.init : {
 		*(.init);
@@ -19,6 +37,40 @@
 		*(.rodata .rodata.*);
 	} :text
+
+#if defined(SHLIB) || defined(DLEXE)
+	.rel.plt : {
+		*(.rel.plt);
+	}
+	/* 
+	 *.rel.dyn MUST FOLLOW IMMEDIATELY after .rel.plt 
+	 * without alignment gap or DT_REL will be broken
+	 */
+	.rel.dyn : {
+		*(.rel.*);
+	} :text
 	
+	.plt : {
+		*(.plt);
+	} :text
+	
+	.dynsym : {
+		*(.dynsym);
+	} :text
+	
+	.dynstr : {
+		*(.dynstr);
+	} :text
+	
+	.hash : {
+		*(.hash);
+	} :text
+#endif
 	. = . + 0x1000;
+	
+#if defined(SHLIB) || defined(DLEXE)
+	.dynamic : {
+		*(.dynamic);
+	} :data :dynamic
+#endif
 	
 	.data : {
@@ -26,4 +78,18 @@
 	} :data
 	
+#if defined(SHLIB) || defined(DLEXE)
+	.data.rel : {
+                *(.data.rel .data.rel.*);
+	} :data
+
+	.got : {
+                *(.got);
+	} :data
+	.got.plt : {
+                *(.got.plt);
+	} :data
+#endif
+	
+#ifndef DLEXE
 	.tdata : {
 		_tdata_start = .;
@@ -37,6 +103,8 @@
 	
 	_tls_alignment = ALIGNOF(.tdata);
+#endif
 	
 	.bss : {
+		*(.dynbss);
 		*(COMMON);
 		*(.bss);
Index: uspace/lib/c/arch/ia32/include/config.h
===================================================================
--- uspace/lib/c/arch/ia32/include/config.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/ia32/include/config.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -36,6 +36,9 @@
 #define LIBC_ia32_CONFIG_H_
 
-#define PAGE_WIDTH	12
-#define PAGE_SIZE	(1 << PAGE_WIDTH)
+#define PAGE_WIDTH  12
+#define PAGE_SIZE   (1 << PAGE_WIDTH)
+
+#define USER_ADDRESS_SPACE_START_ARCH  UINT32_C(0x00000000)
+#define USER_ADDRESS_SPACE_END_ARCH    UINT32_C(0x7fffffff)
 
 #endif
Index: uspace/lib/c/arch/ia32/include/fibril.h
===================================================================
--- uspace/lib/c/arch/ia32/include/fibril.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/lib/c/arch/ia32/include/fibril.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -42,5 +42,5 @@
  * panic sooner or later
  */
-#define SP_DELTA     (12)
+#define SP_DELTA  12
 
 #define context_set(c, _pc, stack, size, ptls) \
@@ -51,6 +51,7 @@
 		(c)->ebp = 0; \
 	} while (0)
-	
-/* We include only registers that must be preserved
+
+/*
+ * We include only registers that must be preserved
  * during function call
  */
